"""
@author: luojunhui
生成文章&&搜索文章
"""
from applications.ai import tencent_ai, kimi_ai, metaSo


class ArticleGeneral(object):
    """
    Generate article with AI
    """

    def __init__(self, params):
        self.text = None
        self.title = None
        self.aic = None
        self.params = params

    def check_params(self):
        """
        校验params
        :return:
        """
        try:
            self.aic = self.params['aic']
            self.title = self.params['title']
            self.text = self.params['text']
            return None
        except AttributeError as err:
            return {"error": "params error {}".format(err)}

    def deal(self):
        """
        处理请求
        :return:
        """
        params_error = self.check_params()
        if params_error:
            return params_error
        else:
            if self.aic == "tencent":
                prompt = "请通过这个标题（{}）, 生成一篇文章".format(self.title)
                response_text = tencent_ai(
                    prompt=prompt
                )
                return {"text": response_text}
            elif self.aic == "kimi":
                if self.text:
                    prompt = "请通过这个标题（{}）和这段正文（{}）, 生成一篇文章".format(self.title, self.text)
                else:
                    prompt = "请通过这个标题（{}）, 生成一篇文章".format(self.title)
                response_text = kimi_ai(prompt)
                return {"text": response_text}
            elif self.aic == "meta":
                if self.text:
                    prompt = "请通过这个标题（{}）和这段正文（{}）, 生成一篇文章".format(self.title, self.text)
                else:
                    prompt = "请通过这个标题（{}）, 生成一篇文章".format(self.title)
                response_text = metaSo(prompt)
                return {"text": response_text}
            else:
                return {"error": "errors"}
